
import java.io.*;
public class CheckersPlayer
{
    public CheckersBoard cBoard;
    public boolean first;
    public boolean ourMove;
    public int depth;
    public int cDepth;
    public int limit = 19;
    public int minSent;
    public int maxSent;
    public CheckersBoard prevState;
    
     boolean blackOver = false;
    
    public CheckersPlayer(boolean firstMove)
    {
        first = firstMove;
        cBoard =  new CheckersBoard(first);
        ourMove = first;
        depth = 9;
        cDepth = 0;
        prevState = cBoard;
    }
    
    
    public void initializeBoard()
    {
        for(int i = 0; i<3; i++)
        {
            for(int j=0; j<8; j++)
            {
                if((i%2)==0 && (j%2)==0)
                {
                    cBoard.board[i][j]='b';
                }
                
                else if((i%2)==1 && (j%2)==1)
                {
                    cBoard.board[i][j]='b';
                }
                
                else 
                    cBoard.board[i][j]='-';
            }
        }
        
        for(int i=5; i<8; i++)
        {
            for(int j=0; j<8; j++)
            {
                if((i%2)==0 && (j%2)==0)
                {
                    cBoard.board[i][j]='r';
                }
                
                else if((i%2)==1 && (j%2)==1)
                {
                    cBoard.board[i][j]='r';
                }
                
                else 
                    cBoard.board[i][j]='-';
            }
        }
        
        for(int i=3; i<5; i++)
        {
            for(int j=0; j<8; j++)
            {
                cBoard.board[i][j] ='-';
            }
        }
    }
    
    public void printBoard()
    {
        for(int i=7; i>=0; i--)
        {   

            for(int j=0; j<8; j++)
            {
                System.out.print(cBoard.board[i][j]+"  ");
            }
            System.out.println();
           
            
        }
         System.out.println();
         System.out.println();
        
    }

    
    public void getOpponentMove()
    {
        char cMove[] = new char[3];
        String move = "";
        int pointer = 0;
        System.out.println();
        System.out.println();
        System.out.println("Please enter your next move");
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        try
        {
            move = in.readLine();
            cMove = move.toCharArray();
        }catch(Exception e){System.out.println("could not read move");}
        if(move.equals("undo"))
        {   System.out.println("undo used");
            undoMove();
            printBoard();
            getOpponentMove();
        }
        else    
        {
            while(!((pointer+2) >= cMove.length))
            {
           
                cBoard.move((int)cMove[pointer]-48, (int)cMove[pointer+1]-48, (int)cMove[pointer+2]-48,(int)cMove[pointer+3]-48);
                pointer +=2;
                prevState = cBoard;
                System.out.println(move);
            }
        }
    }
    
    public void undoMove()
    {
        cBoard = prevState;
    }
    
    boolean isOver(CheckersBoard state, char player)
    {
        int red = 0;
        int black = 0;
        state.successor(player);
        for(int i = 0; i<8; i++)
        {
            for(int j=0; j<8; j++)
            {
                if(state.board[i][j]=='r' || state.board[i][j]=='R')
                    red++;
                if(state.board[i][j]=='b' || state.board[i][j]=='B')
                    black++;
            }
        }
        if(red==0 || black ==0)
            {   if(player == 'b')
                    blackOver = true;
                return true;
            }
        else if(cBoard.successors[0] == null)
            {
                if(player == 'b')
                    blackOver = true;
                return true;
            }
        else
            return false;
    }
    
    public CheckersBoard getNextMove()
    {
        int i = 0;
        cBoard.successor('b');
        while(cBoard.successors[i] != null)
        {
            if(cBoard.successors[i].jumpMade)
                return cBoard.successors[i];
            i++;
        }
        //CheckersBoard nextMove=miniMax();
        return miniMax();
        
    }   
    
    
    public CheckersBoard miniMax()
    {
        minSent = 10000;
        maxSent = -10000;
        cDepth = 0;
        int value = max(cBoard);
        int i=0;
        CheckersBoard nextMove = new CheckersBoard(ourMove);
        while(cBoard.successors[i] != null)
        {
            if(cBoard.successors[i].heuristic == value)
              { nextMove = cBoard.successors[i];
                return nextMove;
              }
            i++;
        }
        return nextMove; 
    }
    
    public int max(CheckersBoard state)
    {
        int value = 0;
        if(isOver(state, 'b') || this.limit< this.cDepth)
          {
            state.getHeuristic();
            value = state.heuristic;
            return value;
          }
        else
        {
            CheckersBoard nextMove= new CheckersBoard(ourMove);
            this.cDepth++;
            state.successor('b');
            int i=0;
            
            while(state.successors[i] != null)
            {
               // state.successor[i].successor('r');
               // state.successors[i].heuristic = maxValue(maxSent, min(state.successors[i]));
                value = maxValue(maxSent, min(state.successors[i]));
                state.successors[i].heuristic = value;
                i++;
            }
            return value;
        }
    }
     
     public int min(CheckersBoard state)
     {
         int value = 0;
         if(isOver(state, 'r') || this.limit< this.cDepth)
            {
                state.getHeuristic();
                value = state.heuristic;
                return value;
             
            }
         else
         {  
             CheckersBoard nextMove= new CheckersBoard(ourMove);
             this.cDepth++;
             state.successor('r');
             int i=0;
             while(state.successors[i] != null)
             {
                 
                 //nextMove = minValue(minSent, max(state));
                 value = minValue(minSent, max(state.successors[i]));
                 state.successors[i].heuristic = value;
                 i++;
             }
             return value;
         }
     }
    
      public int minValue(int sent, int state)
      {
         if(sent < state)
            return sent;
         else
            return state;
         
      }
      
      public int maxValue(int sent, int state)
      {
          if(sent > state)
            return sent;
          else
            return state;
      }    
    public String getGoesFirst()     
    {
        String goesFirst="";
        System.out.println("Who goes first? ('red' or 'black')");
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        try
        {
            goesFirst = in.readLine();
          
        }catch(Exception e){System.out.println("Error");}
        return goesFirst;
    }
    
    public static void main()
    {
        CheckersPlayer p = new CheckersPlayer(true);
        p.initializeBoard();
        if(p.getGoesFirst().equals("black"))
          {  
              p.cBoard.move(2,2,3,3);
              System.out.println("2233");
          }
             
        
        p.printBoard();
        while(!p.isOver(p.cBoard, 'r') && !p.blackOver)
        {
            
            p.getOpponentMove();
            p.printBoard();
            if(!p.isOver(p.cBoard, 'b'))
            {
                
                //p.prevState = p.cBoard;
                p.cBoard = p.getNextMove();
                p.printBoard();
                System.out.println(p.cBoard.moveName);
            }
        }
        System.out.println("Game Over");
    }
}
        